package helm

import "fmt"

const (
	ErrorValuesYamlNotFoundf = "could not find file %s in chart"
)

// ErrorValuesFileNotFound is returned when a value.yaml is not found when attemping to access it from a chart
type ErrorValuesFileNotFound struct {
	error
	filename string
}

func NewErrorValuesFileNotFound(file string) ErrorValuesFileNotFound {
	return ErrorValuesFileNotFound{
		filename: file,
	}
}

func (e ErrorValuesFileNotFound) Error() string {
	return fmt.Sprintf(ErrorValuesYamlNotFoundf, e.filename)
}

func IsErrorValuesFileNotFound(err error) bool {
	_, ok := err.(ErrorValuesFileNotFound)
	return ok
}
